from turtle import *

######### Colors #############
lgreen = '#C2EAD8'
dgreen = '#4EB2AF'
##############################

def drawDisc(radius, color):
    pd()
    pen(fillcolor = color)
    begin_fill()
    circle(radius)
    end_fill()
    pu()

def initializeTurtle(radius):
    """initialize turtle on canvas before drawing"""
    setup(2*radius+200, 2*radius+200) # Create a turtle window
    reset() # Clear any existing turtle drawings
            # and reset turtle position & heading.
    pensize(1) # Choose a pen thickness
    speed(0) # Set the speed; 0=fastest, 1=slowest, 6=normal
    pu()
    setx(0)
    sety(-radius)
    pd()

def testNestedCircles(radius, minRadius, color1=lgreen, color2=dgreen):
    initializeTurtle(radius)
    nestedCircles(radius, minRadius, color1, color2)
    getscreen().getcanvas().postscript(file="figs/nestedCircles({}-{}-{}-{}).eps".format
                            (radius, minRadius, color1, color2))


def nestedCircles(radius, minRadius, color1=lgreen, color2=dgreen):
    if radius < minRadius:
        # do nothing
        return (0, 0)
    else:
        # contribute to the solution
        drawDisc(radius, color1)
        halfRadius = radius/2 # save half of radius

        # position the turtle at the right place
        lt(90); fd(halfRadius); rt(90); fd(halfRadius)

        # draw right subcircle recursively
        r2, r1 = nestedCircles(halfRadius, minRadius, color2, color1)

        # position turtle for left subcircle
        bk(radius)

        # draw left subcircle recursively
        l2, l1 = nestedCircles(halfRadius, minRadius, color2, color1)

        # bring turtle back to start position
        fd(halfRadius);  lt(90);  bk(halfRadius);  rt(90)

        # return values
        return (1 + r1 + l1, r2 + l2)

if __name__ == '__main__':
    #testNestedCircles(300, 300)
    #testNestedCircles(300, 150)
    #testNestedCircles(300, 75)
    #testNestedCircles(300, 37.5)
    #testNestedCircles(300, 18.75)
    testNestedCircles(300, 3)
    exitonclick()
