from turtle import *



def drawTriangle(sideLen):
    pd()
    fd(sideLen)
    lt(120)
    fd(sideLen)
    lt(120)
    fd(sideLen)
    lt(120)
    pu()



def sierpinski(sideLen, level):
    if level == 0:
        pass
    else:
        drawTriangle(sideLen)
        # draw upper triangle first
        lt(60)
        fd(sideLen/2)
        rt(60)
        sierpinski(sideLen/2, level - 1)
        lt(60)
        bk(sideLen/2)
        rt(60)
        # draw lower left triangle next
        sierpinski(sideLen/2, level - 1)
        fd(sideLen/2)
        # draw lower right triangle next)
        sierpinski(sideLen/2, level - 1)
        bk(sideLen/2)

def initializeTurtle(sideLen):
    """initialize turtle on canvas before drawing"""
    setup(sideLen+100, sideLen+100) # Create a turtle window
    reset() # Clear any existing turtle drawings
            # and reset turtle position & heading.
    pensize(2) # Choose a pen thickness
    speed(0) # Set the speed; 0=fastest, 1=slowest, 6=normal

    #shape("turtle") # Make turtle shape a turtle (as opposed to arrow)
    #Turtle, by default, starts roughly in center of canvas
    pu()
    setx(-sideLen/2)
    sety(-sideLen/2)

    # Magical statement to make turtle window come to top of screen.
    # getscreen()._root.attributes('-topmost', True)


def testSierpinski(sideLen, level):
    initializeTurtle(sideLen)
    sierpinski(sideLen, level)
    getscreen().getcanvas().postscript(file="figs/sierpinski-{}-{}.eps".format(sideLen, level))



if __name__ == '__main__':
    """Test calls"""
    #testSierpinski(600, 0)
    #testSierpinski(600, 1)
    #testSierpinski(600, 2)
    #testSierpinski(600, 3)
    #testSierpinski(600, 4)
    #testSierpinski(600, 5)
    testSierpinski(600, 6)
    #testSierpinski(600, 7)
